<?php
 /*
 #########################################################################
 #                       xt:Commerce  4.1 Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2011 xt:Commerce International Ltd. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce  4.1 Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id$
 # @copyright xt:Commerce International Ltd., www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

class csv_pro_import extends csv_pro_api {


	function run_import($data) {


		$this->dir = _SRV_WEBROOT.'export/';

		$this->limit_lower = 0;
		$this->limit_upper = 0;
		
		if (isset($data['limit_lower'])) {
			$this->limit_lower = (int)$data['limit_lower'];
		} 
		
		if (isset($data['limit_upper'])) {
			$this->limit_upper = (int)$data['limit_upper'];
		}

		if (isset($data['counter_new'])) {
			$this->counter_new = (int)$data['counter_new'];
		}

		if (isset($data['counter_update'])) {
			$this->counter_update = (int)$data['counter_update'];
		}
		
		$id = $_GET['id'];
		if (!$this->getDetails($id)) die ('- id not found -');

		//$this->_checkCredentials($data);

		if (!isset($data['limit_lower'])) {
			$this->_startExport($id);
		}

		$this->password = $data['password'];
		$this->user = $data['user'];

		$this->id=$id;
		$this->ei_id = $this->_recordData['ei_id'];
		$this->ei_type = isset($data['ei_type']) ? $data['ei_type'] : 'import';
		$data['type']=$this->_recordData['ei_type_spec'];
		$this->limit=$this->_recordData['ei_limit'];
		$this->file=$this->_recordData['ei_filename'];
		
		$delimiter = $this->_recordData['ei_delimiter'];
		// Workaround for delimiter like \t\t where it will be passed as single quoted string and will not be evaluated
		eval("\$delimiter = \"$delimiter\";");
		$this->delimiter = $delimiter;
        $this->cat_tree_delimiter = $this->_recordData['ei_cat_tree_delimiter'];
		$this->enclosure = $this->_recordData['ei_enclosure'];
		$this->type=$data['type'];
		
		// read header
		$header = $this->readHeader();

		switch ($data['type']) {
			case 'products':
				$this->_import_products();
				break;
		}
	}
	
/**
	 * Import Products Data (products & products_description table)
	 *
	 */
	function _import_products(){
		global $db,$customers_status,$language,$seo,$filter,$price,$xtPlugin;

		// allowed primary keys
		//$allowed_primary=array('products_id','external_id','products_model','products_ean');
		$allowed_primary=explode(',', EI_ALLOWED_PRIMARY);
		
		$this->_checkKeyImport($allowed_primary);

		if($this->secondary){
			$allowed_secondary=explode(',', EI_ALLOWED_SECONDARY);
			$this->_checkKeyImport($allowed_secondary, 'secondary');		
		}
		
		if ($this->limit_upper==0) $this->limit_upper = $this->limit;
		if ($this->limit_lower==0) {
			$this->clearLog();
			$this->limit_lower=1;
		}

		$lower = $this->limit_lower;

		// If the import is marked as multilanguage get list of all languages that we xpect in the csv
		if ($this->_recordData['ei_language']==1) {
			$this->_language_list = $language->_getLanguageList();
		} else {
			// Otherwise get store's default language
			// This will allow us to map single coolumns like "Title" to product name in default language
			$defaultLanguage = array('code' => _STORE_LANGUAGE);
			$this->_language_list = array($defaultLanguage);
		}

		$product_table_fields = $this->readTabelFields(TABLE_PRODUCTS);
		$product_description_table_fields = $this->readTabelFields(TABLE_PRODUCTS_DESCRIPTION);

        ($plugin_code = $xtPlugin->PluginCode('plugin_xt_csv_pro_import.php:_import_products_top')) ? eval($plugin_code) : false;

		for ($i = $lower; $i<$this->limit_upper && $i<$this->line_count;$i++) {
			$line_data = $this->_parseLineData($i);
			
			foreach ($this->_objectMapping as $fieldName => $fieldObj) {
				if (isset($line_data[$fieldName])) {
					$line_data[$fieldName] = $fieldObj->getValueForImport($line_data[$fieldName], $line_data);
				} else {
					// Constant
					$line_data[$fieldObj->getStoreField()] = $fieldObj->getCsvField();
				}
			}

			// Primary key is mandatory for import
			if (!isset($line_data[$this->primary]) && ($this->ei_type == 'improt')) {
				$msg=  '501|Missing primary key column. Please setup filds mapping<br />';
				$this->addLog($msg);
				die($msg);
			}

			if ($line_data[$this->primary]=='') {
				$msg=  '501|'.$i.' missing primary key in line :'.$i.'<br />';
				$this->addLog($msg);
			}elseif ($this->secondary !='' && (!isset($line_data[$this->secondary]) or $line_data[$this->secondary]=='')) {
				$msg=  '501|'.$i.' missing secondary key in line :'.$i.'<br />';
				$this->addLog($msg);	
			} else {
				
				if($this->secondary)
				$qry = " and ".$this->secondary."='".$line_data[$this->secondary]."'";

				// check if update or import
				$rs = $db->Execute("SELECT * FROM ".TABLE_PRODUCTS." WHERE ".$this->primary."='".$line_data[$this->primary]."' ".$qry."");

				if ($rs->RecordCount()==1) {
					$action = 'update';
					$products_id = $rs->fields['products_id'];
				} elseif ($rs->RecordCount()==0) {
					$action = 'import';
					$products_id = 0;
				} else {
					$msg= '500|'.$i.' double primary key in line :'.$i.'<br />';
					$this->addLog($msg);
					continue;
				}
				
				//	$line_data['last_modified'] = $db->DBTimeStamp(time());
				if ($action=='update') {

					$update_id = $line_data[$this->primary];
					
					if($this->secondary){
						$update_second_id = $line_data[$this->secondary];
						$qry = " and ".$this->secondary."='".$update_second_id."'";
						unset($line_data[$this->secondary]);
					}
					
					unset($line_data[$this->primary]);
					unset($line_data['products_id']);
					
					if ($this->hasFieldsForInsert(TABLE_PRODUCTS, $line_data)) {
						// set last modified date
						$db->AutoExecute(TABLE_PRODUCTS,$line_data,"UPDATE",$this->primary."='".$update_id."' ".$qry." ");
					}
					$this->counter_update++;
				} else {
					unset($line_data['products_id']);
					
					if ($this->_recordData['ei_type']=='import') { // only insert if ei_type is import
						if ($this->hasFieldsForInsert(TABLE_PRODUCTS, $line_data)) {
							$db->AutoExecute(TABLE_PRODUCTS,$line_data);
							$this->counter_new++;
							$products_id = $db->Insert_ID();
						}
					} else {
						// Import type was set to update do not import new products
						continue;
					}
				}

                ($plugin_code = $xtPlugin->PluginCode('plugin_xt_csv_pro_import.php:_import_products_products_tag')) ? eval($plugin_code) : false;

				// categories tag?
				if ($line_data['categories']!='' && $products_id>0) {
					// import categories
					$categories = array();
					$categories = explode($this->cat_tree_delimiter,$line_data['categories']);

					$db->Execute("DELETE FROM ".TABLE_PRODUCTS_TO_CATEGORIES." WHERE products_id='".$products_id."'");
					$first = true;
					foreach ($categories as $key => $id) {
						$cat_data = array();
						$cat_data['categories_id']=$id;
						$cat_data['products_id']=$products_id;
						$cat_data['master_link']='0';
						if ($first) {
							$cat_data['master_link']='1';
						}
						$db->AutoExecute(TABLE_PRODUCTS_TO_CATEGORIES,$cat_data);
						$first = false;
					}
				}

                if ($line_data['categories_tree']!='' && $products_id>0) {
                    $this->_insertCategory($line_data['categories_tree'],$products_id);
                }
                
                ($plugin_code = $xtPlugin->PluginCode('plugin_xt_csv_pro_import.php:_import_products_categories_tag')) ? eval($plugin_code) : false;
					foreach ($this->_language_list as $key => $val) {
						$description = array();
						foreach ($product_description_table_fields as $field => $name) {
							if ($field != 'products_id' && $field !='language_code') {
								if (isset($line_data[$field.'_'.$val['code']])) {
									
									// insert name if not set (to avoid inconsistend databases)
									if ($field=='products_name' && $line_data[$field.'_'.$val['code']]=='') {
										$line_data[$field.'_'.$val['code']]='Artikel-'.time();
									}						
									$description[$field] = $line_data[$field.'_'.$val['code']];
								}
							}
						}
						if (is_array($description) && $products_id>0) {
							if ($action=='update') {
								if (count($description)>0)
								$db->AutoExecute(TABLE_PRODUCTS_DESCRIPTION,$description,"UPDATE","products_id=".$products_id." and language_code='".$val['code']."'");
							} else {
								$description['products_id']=$products_id;
								$description['language_code']=$val['code'];
								$db->AutoExecute(TABLE_PRODUCTS_DESCRIPTION,$description);
							}
						}

                        ($plugin_code = $xtPlugin->PluginCode('plugin_xt_csv_pro_import.php:_import_products_products_description')) ? eval($plugin_code) : false;

						// update seo urls
						if($line_data['url_text_'.$val['code']] != ''){
							$auto_generate = false;
							$line_data['url_text_'.$val['code']] = $line_data['url_text_'.$val['code']];
						}else{
							$auto_generate = true;
							$line_data['url_text_'.$val['code']] = $line_data['products_name_'.$val['code']];
						}
						if ($products_id>0) {
							$seo->_UpdateRecord('product',$products_id, $val['code'], $line_data,$auto_generate);
						}
					}
			}// IF
		}

        ($plugin_code = $xtPlugin->PluginCode('plugin_xt_csv_pro_import.php:_import_products_bottom')) ? eval($plugin_code) : false;

        $this->_redirecting();

	}


	/**
	 * read first line and return header data.
	 *
	 */
	function readHeader() {
		global $filter;
		
		$this->filedata = array();
		$this->filedata = file($this->dir.$this->file);
		$this->line_count = count($this->filedata);
		$this->count = $this->line_count;

		$this->primary = $this->_recordData['ei_type_match'];
		$this->secondary = $this->_recordData['ei_type_match_2'];
		$header = trim($this->filedata[0]);
		
		$this->mapping = str_getcsv($header, $this->delimiter, $this->enclosure);
		$fields = $this->getExportedFields();
		$mappedFields = array();
		
		foreach ($fields as $fieldObj) {
			// Skip not mapped fields
			if (($fieldObj->getStoreField() == '') || (substr($fieldObj->getStoreField(), 0, strlen("No selection")) == 'No selection')) 
				continue;
			
			$mappedFields[$fieldObj->getCsvField()] = $fieldObj->getStoreField();
			
			// Check if field is mapped twice
			if (isset($this->_objectMapping[$fieldObj->getStoreField()])) {
				$msg = sprintf('Duplicate mapping of %s detected. Stopping.', $fieldObj->getStoreField());
				$this->addLog($msg);
				die($msg);
			}
			$this->_objectMapping[$fieldObj->getStoreField()] = $fieldObj;
		}
		
		if (empty($mappedFields)) {
			$this->addLog(TEXT_ERR_NO_FIELDS_MAPPED_FOR_IMPORT);
			die(TEXT_ERR_NO_FIELDS_MAPPED_FOR_IMPORT);
		}

		foreach ($this->mapping as $key => $val) {
			$val = trim(str_replace(array("\n", "\r", "\n\r"), '', $val),'"');
			if (isset($mappedFields[$val]))
				$this->mapping[$key]=$mappedFields[$val];
			
		}
		
		if (!is_array($this->mapping)) die ('- no columns - ');
	}

	function _redirecting() {
		global $xtLink;

		if ($this->limit_upper<$this->count) {
			// redirect to next step
			$limit_lower =$this->limit_upper;
			$limit_upper =$this->limit_upper+$this->limit;
		
			$params = 'api=csv_pro_import&id='.$this->ei_id.
						'&limit_lower='.$limit_lower.
						'&limit_upper='.$limit_upper.
						'&timer_start='.$this->timer_start.
						'&counter_new='.$this->counter_new.'&counter_update='.$this->counter_update.
						'&ei_type='.$this->ei_type;

			
			echo $this->_displayHTML($xtLink->_link(array('default_page'=>'cronjob.php', 'params'=>$params)),$limit_lower,$limit_upper,$this->count - 1);
			
		} else {
			echo '<br />200 import finished';
			echo '<br />New:'.$this->counter_new;
			echo '<br />Update:'.$this->counter_update;
		}

	}

}

?>